<?php

namespace Netcreators\NcgovPdc\Service\Backend\Controller\Wizard;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Utility\HttpUtility;

class AddController extends \TYPO3\CMS\Backend\Controller\Wizard\AddController
{

    /**
     * Main function
     * Will issue a location-header, redirecting either BACK or to a new alt_doc.php instance...
     *
     * @return    void
     */
    function main()
    {

        if ($this->returnEditConf) {
            parent::main();
        } else {

            // fix for the word 'style' in url which will trigger xss protection, which will make the url validation fail
            $uri = GeneralUtility::getIndpEnv('REQUEST_URI');
            $uri = str_replace('selectedListStyle', 'xx', $uri);
            $uri = str_replace('itemListStyle', 'xx', $uri);

            // Redirecting to alt_doc.php with instructions to create a new record
            // AND when closing to return back with information about that records ID etc.
            $redirectUrl = 'alt_doc.php?returnUrl=' . rawurlencode(
                    $uri
                ) . '&returnEditConf=1&edit[' . $this->P['params']['table'] . '][' . $this->pid . ']=new';

            // pass subtype along
            if ($this->P['params']['table'] === 'tx_ncgovpdc_domain_model_referencelink') {
                if (isset($this->P['params']['subtype'])) {
                    $redirectUrl .= vsprintf(
                        '&subtype=%1$s&type=%2$s',
                        array($this->P['params']['subtype'], $this->P['params']['type'])
                    );
                }
            }

            HttpUtility::redirect($redirectUrl);
        }
    }
}